<template>
  <v-form
    class="pb-5"
    ref="form"
    lazy-validation="lazy-validation"
    @submit.prevent="submitForm"
  >
    <slot
      :model="model"
      :loading="loading"
    />
    <v-alert
      dense="dense"
      dismissible="dismissible"
      v-model="messageAlert"
      :type="(message && message.type) || 'error'"
    >{{message && message.msg}}</v-alert>
    <div class="d-flex">
      <v-spacer />
      <v-btn
        type="submit"
        :loading="loading"
      >{{submitLabel}}</v-btn>
    </div>
  </v-form>
</template>

<script lang="ts">
import Vue from 'vue'
export default Vue.extend({
  name: 'Formulary',
  props: {
    value: {
      type: Object,
      default () {
        return {}
      }
    },
    successMsg: { type: Function, default: null },
    submitLabel: { type: String, default: 'Press' },
    msgTimeout: { type: Number, default: 5000 },
    submit: {
      type: Function,
      default () {
        return (data: any) => console.log('Submitted: ' + data)
      }
    },
    template: { type: Function, default: () => () => ({}) }
  },
  data: (): {
    model: any,
    loading: boolean,
    message: {
      type: string,
      msg: string
    } | null
  } => ({
    model: {},
    loading: false,
    message: null
  }),
  computed: {
    messageAlert: {
      get (): boolean {
        return !!this.message
      },
      set (v: boolean) {
        if (!v) this.message = null
      }
    }
  },
  mounted () {
    this.model = this.template()
  },
  watch: {
    model: {
      deep: true,
      handler (val) {
        this.$emit('input', val)
      }
    }
  },
  methods: {
    async submitForm () {
      const form: any = this.$refs.form

      if (form.validate()) {
        try {
          this.loading = true
          await this.submit(this.model)

          if (this.successMsg) {
            this.message = {
              type: 'success',
              msg: this.successMsg(this.model)
            }

            setTimeout(() => {
              this.message = null
            }, this.msgTimeout)
          }

          this.model = this.template()
        } catch (error) {
          const msg =
            (error && error[0] && error[0].message) || (error && error.message)
          this.message = {
            type: 'error',
            msg
          }
        }
        this.loading = false
      }
    }
  }
})
</script>
